var URL_CONF = 'http://' + window.location.hostname + ':' + window.location.port + '/ned/configuration';
var URL_VERSION = 'http://' + window.location.hostname + ':' + window.location.port + '/ned/version';
var URL_STOP_FOR_DOWNLOAD = 'http://' + window.location.hostname + ':' + window.location.port + '/ned/exit';
var initAskVersion;

fetchInstall = function () {
	if (typeof (configuration) !== 'undefined' && configuration !== null) {
		$.getJSON(URL_CONF,
			function (data) {
				ask_download();
			}
		)
	};
};

check_install = function () {
	initAskVersion = setTimeout(fetchInstall, 2000);
}

//check new version
ask_download = function () {
	$.getJSON(URL_VERSION, function (data) {
		console.log(data);
		var url = data.url;
		var text = data.text;
		var version = data.version;
		var cookie = document.cookie;
		var internet_ok = data.internet_ok;
		var new_version = data.new_version;

		if (this.conf == undefined) {
			this.conf = configuration.configuration;
		}
		if ($.parseJSON(internet_ok) === true) {
			if ($.parseJSON(new_version) === true) {
				//NOTIFICATION NEW VERSION
				$.notify.addStyle('ned',
					{
						html: "<script src='../jsv234/lib.js'></script><div id='div_ask_download'><span data-notify-text/>" + text + "(" + version + ")<br /><form><input type='hidden' id='urlFieldId' name='urlValueId' value=" + url + " /><input id='link_version' onClick='launch_download()' type='button' value='Upgrade'/><input type='button' onClick='cancel_download()' id='no_upgrade' value='Cancel'/></form></div>",
						classes: {
							base: {
								"white-space": "nowrap",
								"background-color": "#8024FF",
								"padding": "30px",
								"margin-top": "100px",
								"border-style": "solid",
								"border-width": "1px",
								"border-color": "black",
								"color": "white",
								"autoHide": false,
								"clickToHide": false,
							}
						}
					});
				$.notify(' ', {
					style: 'ned',
					clickToHide: true,
					autoHide: false
				});
			}

		}
		else {
			$.notify.addStyle('ned',
				{
					html: "<div><span data-notify-text/>" + text + "</div>",
					classes: {
						base: {
							"white-space": "nowrap",
							"background-color": "#8024FF",
							"padding": "30px",
							"margin-top": "100px",
							"border-style": "solid",
							"border-width": "1px",
							"border-color": "black",
							"color": "white"
						}
					}
				});
			$.notify(' ', {
				style: 'ned',
				clickToHide: true,
				autoHide: false
			});
		}
	});
};

launch_download = function () {
	$('#div_ask_download').trigger('notify-hide');
	var value_url = document.getElementById("urlFieldId");
	var strconfirm = confirm(LBL_CONFIRM_UPGRADE);
	if (strconfirm == true) {
		var url = value_url.form.urlValueId.value;
		$(this).attr('href', url);
		SetCookie("fileDownload", true);
		SetCookie("path", "/");
		$.fileDownload($(this).prop('href'), {
			successCallback: function (url) {
				$.notify.addStyle('ned1',
					{
						html: "<script src='../jsv234/lib.js'></script><div id='ask_for_stop'><span data-notify-text/>" + LBL_ASK_STOP + " <br /><form><input type='button' onClick='stop_for_install()' id='id_stop_for_install' value='Ok'/><input type='button' onClick='cancel_download()' id='no_upgrade' value='Cancel'/></form></div>",
						classes: {
							base: {
								"white-space": "nowrap",
								"background-color": "#8024FF",
								"padding": "30px",
								"margin-top": "100px",
								"border-style": "solid",
								"border-width": "1px",
								"border-color": "black",
								"color": "white",
								"autoHide": false,
								"clickToHide": false,
								"margin-left": "100px",
								"left": "0%"
							}
						}
					}
				);
				$.notify(' ', {
					style: 'ned1',
					clickToHide: false,
					autoHide: false

				});
			},
			failCallback: function (responseHtml, url) {
				alert("Something went wrong trying to download the new version. Please try later.")
			}
		});
	}
};

cancel_download = function () {
	$('#div_ask_download, #ask_for_stop').trigger('notify-hide');
	console.log("The user choose to not upgrade. To see the upgrade notification again, restart server.");
};

stop_for_install = function () {
	$('#ask_for_stop').trigger('notify-hide');
	$.ajax({
		url: URL_STOP_FOR_DOWNLOAD,
		type: "GET",
		success: function (code_html, statut) {
			$.blockUI({
				message: LBL_SERVER_STOPPED_DOWNNLOAD,
				css: {
					"cursor": "auto",
					"white-space": "nowrap",
					"background-color": "#8024FF",
					"padding": "30px",
					"margin-top": "150px",
					"border-style": "solid",
					"border-width": "1px",
					"border-color": "black",
					"color": "white",
					"width": "auto",
					"opacity": 0.5,
					"margin-left": "350px",
					"left": "10%"
				},
				overlayCSS: {
					"cursor": 'auto'
				}
			});
		},
		error: function (resultat, statut, erreur) { }
	});
};

$("#link_download").unbind('click').on('click', function (e) {
	e.preventDefault();
	download();
});

$("#no_download").unbind('click').on('click', function (e) {
	e.preventDefault();
	if (this.conf == undefined) {
		this.conf = configuration.configuration;
	}
	this.conf.look_for_new_version = false;
	configuration.postConf({
		"look_for_new_version": false
	});
});
