$(function () {

  //init variables
  this.devices = {};
  this.configuration = {};
  var validNavigation = false;

  $.ajaxSetup({ cache: false });

  //get data configuration json
  $.ajax({
    type: 'GET',
    url: 'http://' + window.location.hostname + ':' + window.location.port + '/ned/configuration'
  }).done(function(data){
    main(data);
  });


  function main(model) {
    this.devices = new Device(model, model.MAX_DEVICES);
    this.configuration = new Configuration(model);
    SetCookie("turn_off", "false");
    // first launch
    $('#callbacks').hide();
    $('#devices').hide();
    $('#connection').hide();
    $('#radio').show();
    if ($('#auth-enabled').is(":visible")) {
      $('#auth-disabled').hide();
    }
    else {
      $('#auth-disabled').show();
      $('#auth-enabled').hide();
    }
    SetCookie("where", "radio");
    $('#left_menu .radioLi').addClass("left-nav-selected");
    $('#left_menu .devicesLi').removeClass("left-nav-selected");
    $('#left_menu .callbacksLi').removeClass("left-nav-selected");
    $("#configurationLi").addClass("permahoover");
    $('#devices fieldset').empty();
    for (i = 1; i <= 5; i++) {
      if (i < 10) {
        $('#devices fieldset').append("<div id='row'><label>- Device " + i + "</label><label for='device" + i + "'>Identifier (hex!)</label><input type='text' id='device" + i + "' name='device" + i + "' /><label for='nameDevice" + i + "'>Name</label><input type='text' id='nameDevice" + i + "' name='nameDevice" + i + "' /></div>");
      }
      else {
        $('#devices fieldset').append("<div id='row'><label>- Device " + i + "</label><label class='sup' for='device" + i + "'>Identifier (hex!)</label><input type='text' id='device" + i + "' name='device" + i + "' /><label class='sup2' for='nameDevice" + i + "'>Name</label><input type='text' id='nameDevice" + i + "' name='nameDevice" + i + "' /></div>");
      }
    }
    $('#devices fieldset').append("<div id='row_button'><button id='validateDevice'>Save</button></div>");
    $('#devices fieldset #row_button').append('<button id="validate-cancel-devices" name="validate-cancel-devices">Cancel</button>');
    $('#devices fieldset').prepend("<legend>Devices configuration</legend>");
    new ctrlRadio(this.configuration);
    new ctrlCallbacks(this.configuration);
    new ctrlDevices(this.devices, this.configuration);
    new ctrlConnection(this.configuration);
  }
});
