var first_launch="";
var link_cpt=0;
var URL_CONF = 'http://'+window.location.hostname+':'+window.location.port+'/ned/configuration'
var DELAY_NOTIF=40000;
$(function(){

  if (!String.prototype.includes) {
     String.prototype.includes = function() {
         'use strict';
         return String.prototype.indexOf.apply(this, arguments) !== -1;
     };
 }

  function SetCookie (name, value) {
  	var argv=SetCookie.arguments;
  	var argc=SetCookie.arguments.length;
  	var expires=(argc > 2) ? argv[2] : null;
  	var path=(argc > 3) ? argv[3] : null;
  	var domain=(argc > 4) ? argv[4] : null;
  	var secure=(argc > 5) ? argv[5] : false;
  	document.cookie=name+"="+escape(value)+
  		((expires===null) ? "" : ("; expires="+expires.toGMTString()))+
  		((path===null) ? "" : ("; path="+path))+
  		((domain===null) ? "" : ("; domain="+domain))+
  		((secure===true) ? "; secure" : "");
  }



  $.getJSON( 'http://'+window.location.hostname+':'+window.location.port+'/ned/version' , function( data ) {
    var url = data.url;
    var text = data.text;
    var version=data.version;
    var cookie = document.cookie

    if(!cookie.includes("version="+version)){
      SetCookie("version",version);
      //NOTIFICATION NEW VERSION
      $.notify.addStyle('ned', {
        html: "<div><span data-notify-text/>"+text+" ("+version+")<br />Click <a style='color:white' target='_blank' href='"+url+"'>here</a> to download</div>",
        classes: {
          base: {
            "white-space": "nowrap",
            "background-color": "#028C7F",
            "padding": "30px",
            "margin-top":"100px",
            "border-style": "solid",
            "border-width": "1px",
            "border-color": "black",
            "color":"white"
          }
        }
      });

      $.notify(' ', {
        style: 'ned',
        autoHideDelay: DELAY_NOTIF,
        clickToHide: true
      });
    }
  });

    $.ajaxSetup({ cache: false });
    var items = {};

    var MAX_DEVICES = 0;
    var jsonValidate={};

//    bla blac var URL_CONF = 'http://'+window.location.hostname+':'+window.location.port+'/ned/configuration'
    /* init */
    $.getJSON( URL_CONF , function( data ) {
      items = data;
      first_launch = data;
      MAX_DEVICES = data.MAX_DEVICES;
      $('#devices #fieldsetDevice').empty();
      for(i=1;i<=MAX_DEVICES;i++){
        if(i<10){
            $('#devices #fieldsetDevice').append("<div id='row'><label>- Device "+i+"</label><label for='device"+i+"'>Identifier (hex!)</label><input type='text' id='device"+i+"' name='device"+i+"' /><label for='nameDevice"+i+"'>Name</label><input type='text' id='nameDevice"+i+"' name='nameDevice"+i+"' /></div>");
          }
          else {
            $('#devices #fieldsetDevice').append("<div id='row'><label>- Device "+i+"</label><label class='sup' for='device"+i+"'>Identifier (hex!)</label><input type='text' id='device"+i+"' name='device"+i+"' /><label class='sup2' for='nameDevice"+i+"'>Name</label><input type='text' id='nameDevice"+i+"' name='nameDevice"+i+"' /></div>");
          }
      }
      $('#devices #fieldsetDevice').append("<div id='row_button'><button id='validateDevice'>Save</button></div>");

      var cpt=1;
      $.each(items.devices,function(key,val){
        $('#devices #device'+cpt+'').val(val.identifier);
        $('#devices #nameDevice'+cpt+'').val(val.name);
        cpt++;
      });

      //});

      // click on OK button into devices page
      $('#devices #validateDevice').click(function(){
        getValuesRadio();
        getValuesDevices();
        getValuesCallbacks();
        console.log(jsonValidate);
        var tab_devices=[];
        var passed=false;
        console.log(jsonValidate.devices);
        for(var i=0;i<jsonValidate.devices.length;i++){
          tab_devices.push(jsonValidate.devices[i].identifier);
        }
        for(i=0;i<tab_devices.length;i++){
          console.log(tab_devices.indexOf(tab_devices[i]));
          if(tab_devices.indexOf(tab_devices[i])!==i){
            passed=true;
            $("#device"+(i+1)).attr("class","error");
          }
        }
        if(passed===false){
          for(var i=1;i<=MAX_DEVICES;i++){
            console.log($("#device"+i));
            $("#device"+i).removeAttr("class");
          }
          postConf(jsonValidate);
        }
        else{
          $.notify.addStyle('ned', {
            html: "<div><span data-notify-text/>"+LBL_PROBLEM_ID+"</div>",
            classes: {
              base: {
                "white-space": "nowrap",
                "background-color": "red",
                "padding": "30px",
                "margin-top":"100px",
                "border-style": "solid",
                "border-width": "1px",
                "border-color": "black",
                "color":"white"
              }
            }
          });

          $.notify(' ', {
            style: 'ned',
            autoHideDelay: 5000,
            clickToHide: true
          });
        }
      });

      // click on Cancel button into devices page
      $('#devices #Cancel').click(function(){
        for(i=0;i<=MAX_DEVICES-1;i++){
          if(items.devices[i]!==undefined){
            $('#devices #device'+(i+1)+'').val(items.devices[i].identifier);
            $('#devices #nameDevice'+(i+1)+'').val(items.devices[i].name);
          }
          else{
            $('#devices #device'+(i+1)+'').val("");
            $('#devices #nameDevice'+(i+1)+'').val("");
          }
        }
      });


      // filling bit rate select
      function setSelectBiteRate(){
        $("#radio #bit-rate").children().remove().end();
        $.each(items.bitRateValues,function(key,val){
          $("#radio #bit-rate").append("<option value="+val+">"+val+"</option>");
        });
      }

      // filling bit rate select
      function setSelectOperatingZone(){
        $("#radio #operating-zone").children().remove().end();
        $.each(items.operatingZoneValues,function(key,val){
          var opt = document.createElement('option');
          opt.textContent = val.name;
          opt.value = val.name;
          $("#radio #operating-zone").append(opt);
        });
      }

      //var rowNum = 1;
      $("#addRowData").click(function(){
        if($("#headers-data").val()!=""&&$("#value-headers-data").val()!=""){
          var row = "<div id='rowNumData_"+rowNum+"'><label>Headers</label><input id='headers-data-"+cpt_data+"' name='headers-data-"+cpt_data+"' value='"+$("#headers-data").val()+"' type='text'/><input id='value-headers-data-"+cpt_data+"' name='value-headers-data' value='"+$("#value-headers-data").val()+"' type='text'></div>";
          rowNum ++;
          cpt_data++;
          $('#add_header_data').append(row);
          $("#headers-data").val("");
          $("#value-headers-data").val("");
        }
      });

      //var rowNumAck = 1;
      $("#addRowAck").click(function(){
        if($("#headers-ack").val()!=""&&$("#value-ack").val()!=""){
          var row = "<div id='rowNumAck_"+rowNumAck+"'><label>Headers</label><input id='headers-ack-"+cpt_ack+"' name='headers-ack-"+cpt_ack+"' value='"+$("#headers-ack").val()+"' type='text'/><input id='value-ack-"+cpt_ack+"' name='value-ack' value='"+$("#value-ack").val()+"' type='text'></div>";
          rowNumAck ++;
          cpt_ack++;
          $('#add_header_ack').append(row);
          $("#headers-ack").val("");
          $("#value-ack").val("");
        }
      });

      //var rowNumStatus = 1;
      $("#addRowStatus").click(function(){
        if($("#headers-status").val()!=""&&$("#value-status").val()!=""){
          var row = "<div id='rowNumStatus_"+rowNumStatus+"'><label>Headers</label><input id='headers-status-"+cpt_status+"' name='headers-status-"+cpt_status+"' value='"+$("#headers-status").val()+"' type='text'/><input id='value-status-"+cpt_status+"' name='value-status' value='"+$("#value-status").val()+"' type='text'></div>";
          rowNumStatus ++;
          cpt_status++;
          $('#add_header_status').append(row);
          $("#headers-status").val("");
          $("#value-status").val("");
        }
      });

      // set the bite rate value
      function setRadioValue(){
        var choice = $("#radio #operating-zone").val();
        setSelectBiteRate();
        $.each(items.radio,function(key,val){
          $.each(val,function(key2,val2){
            if(choice!==undefined){
              if(choice.localeCompare(key2)===0){
                $('#radio #uplink-frequency').val(val2.uplink);
                $('#radio #uplink-frequency').attr("disabled","true");
                $('#radio #downlink-frequency').val(val2.downlink);
                $('#radio #downlink-frequency').attr("disabled","true");
                $("#radio #bit-rate option[value='"+val2.bitRate+"']").attr("selected","selected");
                if(choice!="Other"){
                  $('#radio #bit-rate').attr("disabled","true");
                }
                else{
                  $('#radio #bit-rate').removeAttr("disabled");
                }
              }
            }
          });
        });
      }

      $( "#radio #operating-zone" ).change(function() {
        var choice = $("#radio #operating-zone").val();
        $("#radio #operating-zone[value='"+choice+"']").attr("selected","selected");
        if(choice!="Other"){
          setRadioValue();
        }
        else {
          $('#radio #uplink-frequency').removeAttr("disabled");
          $('#radio #uplink-frequency').val(items.radio[3].Other.uplink);
          $('#radio #downlink-frequency').removeAttr("disabled");
          $('#radio #downlink-frequency').val(items.radio[3].Other.downlink);
          $('#radio #bit-rate').val(items.radio[3].Other.bitRate);
          $('#radio #bit-rate').removeAttr("disabled");
        }
      });

      var choice = items.radio_choice;
      setSelectOperatingZone();
      $("#radio #operating-zone option[value='"+choice+"']").attr("selected","selected");
      $("#radio #operating-zone").change();
      setRadioValue();
      if(choice==="Other"){
          $('#radio #uplink-frequency').removeAttr("disabled");
          $('#radio #downlink-frequency').removeAttr("disabled");
          $('#radio #bit-rate').removeAttr("disabled");
      }



  });

  function sortObject(myObj){
    var keys = [];
    var k;
    var copy = myObj;
    for (var k in myObj) {
      if (myObj.hasOwnProperty(k)) {
        keys.push(k);
      }
    }
    keys.sort();
    myObj={};
    for(var k in keys){
      myObj[keys[k]] = copy[keys[k]];
    }
    return myObj;
  }



  function control_before_quit(where){
    var control_return=false;
    console.log(where);
    var cookie = where;
    if(cookie.includes("devices")){
      //console.log(jQuery.unique(items.devices));
      //console.log(items.devices);
      getValuesDevices();
      if(JSON.stringify(items.devices) !== JSON.stringify(jsonValidate.devices)){
         control_return=true;
      }
    }
    if(cookie.includes("radio")){
      console.log(items.radio_choice+" "+$("#radio #operating-zone").val());
      if(items.radio_choice!==$("#radio #operating-zone").val()){
        control_return=true;
      }
      else if(items.radio_choice==="Other"){
        console.log(items.radio[3].Other.uplink+" "+$("#radio #uplink-frequency").val());
        console.log(items.radio[3].Other.downlink+" "+$("#radio #downlink-frequency").val());
        console.log(items.radio[3].Other.bitRate+" "+$("#radio #bit-rate").val());
        if(items.radio[3].Other.uplink !== $("#radio #uplink-frequency").val()){
          control_return=true;
        }
        else if(items.radio[3].Other.downlink !== $("#radio #downlink-frequency").val()){
            control_return=true;
        }
        else if(items.radio[3].Other.bitRate !== $("#radio #bit-rate").val()){
            control_return=true;
        }
      }
    }
    if(cookie.includes("callbacks")){
      getValuesCallbacks();
      jsonValidate.callbacks = sortObject(jsonValidate.callbacks);
      items.callbacks = sortObject(items.callbacks);
      if(JSON.stringify(items.callbacks) !== JSON.stringify(jsonValidate.callbacks)){
        control_return=true;
      }
    }
    return control_return;
  }

    function getConfiguration(){
      $.getJSON( URL_CONF, function( data ) {
        items = data;
        MAX_DEVICES = data.MAX_DEVICES;
      });
      return items;
    }

    /** ******************************************************************* */
    /** ********************* CLICK function ****************************** */
    /** ******************************************************************* */


    function getValuesDevices(){
      jsonValidate.devices=[];
      var devices=[];
      for(i=1;i<=MAX_DEVICES;i++){
        if($('#devices #device'+i+'').val()!=""){
          if(devices[i-1]===undefined){
            devices[i-1]={"name":"","identifier":""}
          }
          devices[i-1].identifier=$('#devices #device'+i+'').val();
          devices[i-1].name=$('#devices #nameDevice'+i+'').val();
          jsonValidate.devices.push({"name":devices[i-1].name,"identifier":devices[i-1].identifier});
        }
      }
    }


    // click on the top menu
    $('#link_messages').click(function(){
      if(!document.cookie.includes("messages")){
         var ret = control_before_quit(document.cookie);
         console.log(ret);
         if(ret){
           if(confirm(LBL_NOT_SAVED)){
              SetCookie("where","messages");
              console.log(document.cookie);
              $('#content_configuration').empty();
              $('#content_messages').load("messages.html");
            }
          }
          else{
            SetCookie("where","messages");
            console.log(document.cookie);
            $('#content_configuration').empty();
            $('#content_messages').load("messages.html");
          }
        }
        else{
          SetCookie("where","messages");
          console.log(document.cookie);
          $('#content_configuration').empty();
          $('#content_messages').load("messages.html");
        }
     })

    var getQueryString = function ( field, url ) {
        var href = url ? url : window.location.href;
        var reg = new RegExp( '[?&]' + field + '=([^&#]*)', 'i' );
        var string = reg.exec(href);
        return string ? string[1] : null;
    };

    if(getQueryString("refresh")!=undefined){
      $('#link_messages').click();
    }


    function loadConfiguration(){
      SetCookie("where","radio");
      console.log(document.cookie);
       $('#content_configuration').load("configuration.html");
       $('#content_messages').empty();
       $('#radio').show();
       console.log(first_launch);
       items = first_launch;
       var choice = first_launch.radio_choice;
       $("#radio #operating-zone").children().remove().end();
       $.each(first_launch.operatingZoneValues,function(key,val){
         var opt = document.createElement('option');
         opt.textContent = val.name;
         opt.value = val.name;
         $("#radio #operating-zone").append(opt);
       });
       $("#radio #operating-zone option[value='"+choice+"']").attr("selected","selected");
       $("#radio #operating-zone").change();
    }

     var items={};
     $('#link_configuration').click(function(){
       if(!document.cookie.includes("radio")){
          var ret = control_before_quit(document.cookie);
          console.log(ret);
          if(ret){
            if(confirm(LBL_NOT_SAVED)){
              loadConfiguration();
            }
          }
          else{
            loadConfiguration();
          }
        }
        else{
          loadConfiguration();
        }
      })

    // first launch
    $('#callbacks').hide();
     $('#devices').hide();
     $('#radio').show();
     SetCookie("where","radio");
     $('#left_menu .radioLi').addClass( "left-nav-selected" );
     $('#left_menu .devicesLi').removeClass( "left-nav-selected" );
     $('#left_menu .callbacksLi').removeClass( "left-nav-selected" );

         // click on the left menu (RADIO)
     $('#link_radio').click(function(){
       if(!document.cookie.includes("radio")){
          var ret = control_before_quit(document.cookie);
          if(ret){
            if(confirm(LBL_NOT_SAVED)){
              SetCookie("where","radio");
              console.log(document.cookie);
              $('#devices').hide();
              $('#callbacks').hide();
              $('#radio').show();
              $('ul .radioLi').addClass( "left-nav-selected" );
              $('ul .devicesLi').removeClass( "left-nav-selected" );
              $('ul .callbacksLi').removeClass( "left-nav-selected" );
            }
          }
          else{
            $('#devices').hide();
            $('#callbacks').hide();
            $('#radio').show();
            $('ul .radioLi').addClass( "left-nav-selected" );
            $('ul .devicesLi').removeClass( "left-nav-selected" );
            $('ul .callbacksLi').removeClass( "left-nav-selected" );
          }
       }
     })

     function loadDevices(){
       SetCookie("where","devices");
       $('#radio').hide();
       $('#callbacks').hide();
       $('#devices').show();
       $('ul .devicesLi').addClass( "left-nav-selected" );
       $('ul .radioLi').removeClass( "left-nav-selected" );
       $('ul .callbacksLi').removeClass( "left-nav-selected" );
     }

     var getQueryString = function ( field, url ) {
         var href = url ? url : window.location.href;
         var reg = new RegExp( '[?&]' + field + '=([^&#]*)', 'i' );
         var string = reg.exec(href);
         return string ? string[1] : null;
     };


     // click on the left menu (DEVICES)
     $('#link_devices').click(function(){
       if(getQueryString("not_cookie")!=undefined){
         loadDevices();
       }
       else{
         console.log(document.cookie);
         var cookie = document.cookie;
         if(!cookie.includes("devices")){
           console.log(document.cookie);
            var ret = control_before_quit(document.cookie);
            if(ret){
              if(confirm(LBL_NOT_SAVED)){
                loadDevices();
              }
            }
            else{
              loadDevices();
            }
          }
          else{
            loadDevices();
          }
       }
     })

     var rowNum = 1;
     var rowNumAck = 1;
     var rowNumStatus = 1;
     var cpt_data = 1;
     var cpt_ack = 1;
     var cpt_status = 1;

     function setValuesCallbacks(){
       var items = getConfiguration();
         $("#callbacks #downlinkMode").val(items.callbacks.downlinkMode);
         if($("#callbacks #downlinkMode").val()==="CALLBACK" || $("#callbacks #downlinkMode").val()==="NO DOWNLINK"){
           $("#callbacks #downlink").val('');
           $("#callbacks #downlink").attr("disabled","disabled");
         }
         else{
           $("#callbacks #downlink").val(items.callbacks.downlinkData);
         }
         if($("#callbacks #downlinkMode").val()==="DIRECT"&&$("#callbacks #downlink").val()===""){
           $("#infoDataPB").show();
         }
         if($("#callbacks #downlinkMode").val()==="DIRECT"){
           $("#choice_callback").hide();
         }
         else{
           $("#choice_callback").show();
         }
        //  //DATA CALLBACK
        $("#callbacks #type_data").val(items.callbacks.type_data);
        $("#callbacks #cbType").val(items.callbacks.cbType);
        $("#callbacks #channel-data").val(items.callbacks.channel_data);
        $("#callbacks #channel-data").change();
        if(items.callbacks.send_duplicate===true){
          $("#callbacks #send-duplicate").attr("checked","checked");
        }

        $("#callbacks #urlPattern-data").val(items.callbacks.urlPattern_data);
        if(items.callbacks.http_post_data===true){
          $("#callbacks #http-post-data").attr("checked","checked");
        }
        if($("#callbacks #channel-data").val()==="BATCH-URL"){
          $("#callbacks #http-post-data").attr("disabled","disabled");
          $("#callbacks #linePattern-data").val(items.callbacks.linePattern_data);
         }

        //$('#add_header_data').remove().end();
         for(var i in items.callbacks.headers_data){
           var row = "<div id='rowNumData_"+rowNum+"'><label>Headers</label><input id='headers-data-"+cpt_data+"' name='headers-data-"+cpt_data+"' value='"+items.callbacks.headers_data[i].header+"' type='text'/><input id='value-headers-data-"+cpt_data+"' name='value-headers-data' value='"+items.callbacks.headers_data[i].value+"' type='text'></div>";
           rowNum ++;
           cpt_data++;
           $('#add_header_data').append(row);
         }

         for(var i in items.callbacks.headers_ack){
           var row = "<div id='rowNumAck_"+rowNumAck+"'><label>Headers</label><input id='headers-ack-"+cpt_ack+"' name='headers-ack-"+cpt_ack+"' value='"+items.callbacks.headers_ack[i].header+"' type='text'/><input id='value-ack-"+cpt_ack+"' name='value-ack' value='"+items.callbacks.headers_ack[i].value+"' type='text'></div>";
           rowNumAck ++;
           cpt_ack++;
           $('#add_header_ack').append(row);
         }

         for(var i in items.callbacks.headers_status){
           var row = "<div id='rowNumStatus_"+rowNumStatus+"'><label>Headers</label><input id='headers-status-"+cpt_status+"' name='headers-status-"+cpt_status+"' value='"+items.callbacks.headers_status[i].header+"' type='text'/><input id='value-status-"+cpt_status+"' name='value-status' value='"+items.callbacks.headers_status[i].value+"' type='text'></div>";
           rowNumStatus ++;
           cpt_status++;
           $('#add_header_status').append(row);
         }
        //$("#callbacks #headers-data").val(items.callbacks.headers_data);
        //$("#callbacks #value-headers-data").val(items.callbacks.value_headers_data);
        //  //ACK
        $("#callbacks #channel-name-ack").val(items.callbacks.channel_name_ack);
        $("#callbacks #channel-ack").val(items.callbacks.channel_ack);
        $("#callbacks #channel-ack").change();
        if(items.callbacks.http_post_ack===true){
          $("#callbacks #http-post-ack").attr("checked","checked");
        }
        console.log(items.callbacks);
         if(items.callbacks.channel_ack==="BATCH-URL"){
           $("#callbacks #http-post-ack").attr("disabled","disabled");
           $("#callbacks #linePattern-ack").val(items.callbacks.linePattern_ack);
         }
         if(items.callbacks.send==true){
           $("#callbacks #send").attr("checked","checked");
         }
        $("#callbacks #urlPattern-ack").val(items.callbacks.urlPattern_ack);
        //$("#callbacks #headers-ack").val(items.callbacks.headers_ack);
        //$("#callbacks #value-ack").val(items.callbacks.value_ack);
        //  //STATUS
        $("#callbacks #channel-name-status").val(items.callbacks.channel_name_status);
        $("#callbacks #channel-status").val(items.callbacks.channel_status);
        if(items.callbacks.http_post_status===true){
          $("#callbacks #http-post-status").attr("checked","checked");
        }
        $("#callbacks #channel-status").change();
        if(items.callbacks.channel_status==="BATCH-URL"){
           $("#callbacks #http-post-status").attr("disabled","disabled");
           $("#callbacks #linePattern-status").val(items.callbacks.linePattern_status);
         }
         if(items.callbacks.send_status===true){
           $("#callbacks #send-status").attr("checked","checked");
         }
        $("#callbacks #send-status").val(items.callbacks.send_status);
        $("#callbacks #urlPattern-status").val(items.callbacks.urlPattern_status);
        //$("#callbacks #headers-status").val(items.callbacks.headers_status);
        //$("#callbacks #value-status").val(items.callbacks.value_status);
     }

     $('#callbacks #Cancel').click(function(){
       setValuesCallbacks();
     })

     function loadCallbacks(){
       SetCookie("where","callbacks");
       console.log(document.cookie);
       $('#radio').hide();
       $('#devices').hide();
       $('#callbacks').show();
       $('ul .callbacksLi').addClass( "left-nav-selected" );
       $('ul .radioLi').removeClass( "left-nav-selected" );
       $('ul .devicesLi').removeClass( "left-nav-selected" );
       $('#data-line').hide();
       $('#data-url').show();
       $('#ack-line').hide();
       $('#ack-url').show();
       $('#status-line').hide();
       $('#status-url').show();
       $('#infoComboBIDIR').hide();
       $('#infoComboDirect').hide();
       $('#infoDataPB').hide();
       setValuesCallbacks();
       // control choice following conf
       if($("#downlinkMode").val()==="DIRECT"){
         $("#cbType option[value='BIDIR']").attr("disabled", true);
       }
     }

     // click on the left menu (CALLBACK)
     $('#link_callbacks').click(function(){
       console.log(document.cookie);
       if(!document.cookie.includes("callbacks")){
          var ret = control_before_quit(document.cookie);
          if(ret){
            if(confirm(LBL_NOT_SAVED)){
              loadCallbacks();
            }
          }
          else {
            loadCallbacks();
          }
        }
        else{
          loadCallbacks();
        }
    });

    $( "#downlinkMode" ).click(function() {
      if($("#cbType").val()=="BIDIR"){
        setTimeout(function(){
          $("#infoComboBIDIR").show();
        }, 600);
      }
    });

  $( "#downlinkMode" )
  .focusout(function() {
    $("#infoComboBIDIR").hide();
  })


    $( "#cbType" ).click(function() {
      if($("#downlinkMode").val()==="DIRECT"&&$("#cbType").val()==="UPLINK"){
        $("#downlink").removeAttr("disabled");
      }
      if($("#downlinkMode").val()==="DIRECT"){
        setTimeout(function(){
          $("#infoComboDirect").show();
        }, 600);
      }
    });

    function postConf (data){

        $.ajax({

               url : "http://"+window.location.hostname+":"+window.location.port+"/ned/configuration",
               type : "POST",
               dataType : "json",
               data  : JSON.stringify(data),
               success : function(code_html, statut){ // success est toujours
														// en place, bien sûr !
                 console.log("success POST");
               },

               error : function(resultat, statut, erreur){
                 console.log("error POST");
               }

            });

            //SAVED
            $.notify.addStyle('ned', {
              html: "<div><span data-notify-text/>"+LBL_SAVED+"</div>",
              classes: {
                base: {
                  "white-space": "nowrap",
                  "background-color": "#028C7F",
                  "padding": "30px",
                  "margin-top":"100px",
                  "border-style": "solid",
                  "border-width": "1px",
                  "border-color": "black",
                  "color":"white"
                }
              }
            });

            $.notify(' ', {
              style: 'ned',
              autoHideDelay: 5000,
              clickToHide: true
            });

            $.ajax({

                   url : "http://"+window.location.hostname+":"+window.location.port+"/ned/configuration",
                   type : "GET",
                   success : function(code_html, statut){ // success est toujours
                                // en place, bien sûr !
                     items = code_html;
                   },

                   error : function(resultat, statut, erreur){
                     console.log("error POST2");
                   }

                });

      }

      $("#downlink").focusout(function() {
        var isValid = $("#downlink").val().match("(?:0[xX])?[0-9a-fA-F]{8}");
        if(!isValid&&$("#downlinkMode").val()==="DIRECT"){
          $("#infoDataPB").show();
        }
        else{
          $("#infoDataPB").hide();
        }
      })


      function getValuesRadio(){
        // items.radio.bitRate = $("#radio #bit-rate").val();
        // items.radio.downlink = $("#radio #downlink-frequency").val();
        // items.radio.uplink = $("#radio #uplink-frequency").val();
        jsonValidate = { 'radio_choice' : $("#radio #operating-zone").val()};
        jsonValidate.radio="";
        jsonValidate.MAX_DEVICES = items.MAX_DEVICES;
        jsonValidate.operatingZoneValues = items.operatingZoneValues;
        jsonValidate.bitRateValues = items.bitRateValues;
        //jsonValidate.radio.operatingZone = $("#radio #operating-zone").val();
        jsonValidate.radio=items.radio;
        if($("#radio #operating-zone").val()==="Other"){
          jsonValidate.radio=items.radio;
          // jsonValidate.radio.Other={};
          jsonValidate.radio[3].Other.uplink = $("#radio #uplink-frequency").val();
          jsonValidate.radio[3].Other.downlink = $("#radio #downlink-frequency").val();
          jsonValidate.radio[3].Other.bitRate = $("#radio #bit-rate").val();

        }

        // jsonValidate = { 'operatingZone' : items.radio.operatingZone,
        //     'uplink':items.radio.uplink,
        //       'downlink':items.radio.downlink,
        //     'bitRate':items.radio.bitRate};
      }


      // // click on OK button into devices page
      // $('#devices #validateDevice').click(function(){
      //   console.log("devices click");
      //   getValuesRadio();
      //   getValuesDevices();
      //   getValuesCallbacks();
      //   console.log(jsonValidate);
      //   var tab_devices=[];
      //   var passed=false;
      //   console.log(jsonValidate.devices);
      //   for(var i=0;i<jsonValidate.devices.length;i++){
      //     tab_devices.push(jsonValidate.devices[i].identifier);
      //   }
      //   for(i=0;i<tab_devices.length;i++){
      //     console.log(tab_devices.indexOf(tab_devices[i]));
      //     if(tab_devices.indexOf(tab_devices[i])!==i){
      //       passed=true;
      //       $("#device"+(i+1)).attr("class","error");
      //     }
      //   }
      //   if(passed==false){
      //     for(var i=1;i<=MAX_DEVICES;i++){
      //       console.log($("#device"+i));
      //       $("#device"+i).removeAttr("class");
      //     }
      //     postConf(jsonValidate);
      //   }
      //   else{
      //     $.notify.addStyle('ned', {
      //       html: "<div><span data-notify-text/>Problem same identifier</div>",
      //       classes: {
      //         base: {
      //           "white-space": "nowrap",
      //           "background-color": "red",
      //           "padding": "30px",
      //           "margin-top":"100px",
      //           "border-style": "solid",
      //           "border-width": "1px",
      //           "border-color": "black",
      //           "color":"white"
      //         }
      //       }
      //     });
      //
      //     $.notify(' ', {
      //       style: 'ned',
      //       autoHideDelay: 5000,
      //       clickToHide: true
      //     });
      //   }
      // });

    // click on OK button into radio page
     $('#radio #validate').click(function(){
       getValuesRadio();
       getValuesDevices();
       getValuesCallbacks();
       if(items.radio.downlink ==="" && items.radio.uplink===""){
         //NOTIFICATION NEW VERSION
         $.notify.addStyle('ned_error', {
           html: "<div><span data-notify-text/></div>",
           classes: {
             base: {
               "white-space": "nowrap",
               "background-color": "#E63D2F",
               "padding": "30px",
               "margin-top":"100px",
               "border-style": "solid",
               "border-width": "1px",
               "border-color": "black",
               "color":"white"
             }
           }
         });

         $.notify('UPLINK and DOWNLINK is required', {
           style: 'ned_error',
           clickToHide: true
         });

       }
       postConf(jsonValidate);
     });

     function getValuesCallbacks(){
       jsonValidate.callbacks={};
       jsonValidate.callbacks.channel_ack=$("#callbacks #channel-ack").val();
       jsonValidate.callbacks.downlinkData=$("#callbacks #downlink").val();
       jsonValidate.callbacks.headers_status=[];
       $("[id^=rowNumStatus]").filter(function(){
         var id=this.id.substring(this.id.indexOf("_")+1,this.id.length);
         if($("#headers-status-"+id).val()!=""&&$("#value-status-"+id).val()!=""){
           var header_status={"header":"","value":""};
           header_status.header=$("#headers-status-"+id).val();
           header_status.value=$("#value-status-"+id).val();
           jsonValidate.callbacks.headers_status.push(header_status);
         }
       });
       jsonValidate.callbacks.http_post_data=$("#callbacks #http-post-data").prop("checked");
       jsonValidate.callbacks.http_post_status=$("#callbacks #http-post-status").prop("checked");
       jsonValidate.callbacks.send_duplicate=$("#callbacks #send-duplicate").prop("checked");
       jsonValidate.callbacks.channel_status=$("#callbacks #channel-status").val();
       jsonValidate.callbacks.headers_data=[];
       $("[id^=rowNumData]").filter(function(){
         var id=this.id.substring(this.id.indexOf("_")+1,this.id.length);
         if($("#headers-data-"+id).val()!=""&&$("#value-headers-data-"+id).val()!=""){
           var header_data={"header":"","value":""};
           header_data.header=$("#headers-data-"+id).val();
           header_data.value=$("#value-headers-data-"+id).val();
           jsonValidate.callbacks.headers_data.push(header_data);
         }
       });
       jsonValidate.callbacks.urlPattern_status=$("#callbacks #urlPattern-status").val();
       jsonValidate.callbacks.channel_data=$("#callbacks #channel-data").val();
       jsonValidate.callbacks.headers_ack=[];
       $("[id^=rowNumAck]").filter(function(){
         var id=this.id.substring(this.id.indexOf("_")+1,this.id.length);
         if($("#headers-ack-"+id).val()!=""&&$("#value-ack-"+id).val()!=""){
           var header_ack={"header":"","value":""};
           header_ack.header=$("#headers-ack-"+id).val();
           header_ack.value=$("#value-ack-"+id).val();
           jsonValidate.callbacks.headers_ack.push(header_ack);
         }
       });
       jsonValidate.callbacks.urlPattern_ack=$("#callbacks #urlPattern-ack").val();
       jsonValidate.callbacks.type_data=$("#callbacks #type_data").val();
       jsonValidate.callbacks.send=$("#callbacks #send").prop("checked");
       jsonValidate.callbacks.http_post_ack=$("#callbacks #http-post-ack").prop("checked");
       if(($("#callbacks #downlinkMode").val()==="DIRECT") || ($("#callbacks #downlinkMode").val()==="NO DOWNLINK")){
         jsonValidate.callbacks.cbType="UPLINK";
       }
       else{
         jsonValidate.callbacks.cbType="BIDIR";
       }
       jsonValidate.callbacks.urlPattern_data=$("#callbacks #urlPattern-data").val();
       if(jsonValidate.callbacks.channel_data==="BATCH-URL"){
         jsonValidate.callbacks.linePattern_data=$("#callbacks #linePattern-data").val();
       }
      //  var cpt_value=0;
      //  $("[id^=value-headers-data]").filter(function(){
      //    console.log(this.value);
      //    header_data.value=this.value;
      //    jsonValidate.callbacks.headers_data.push(header_data);//(this.value);
      //  });
      //  console.log(jsonValidate.callbacks.headers_data);
       //jsonValidate.callbacks.headers_data=$("#callbacks #headers-data").val();
       //jsonValidate.callbacks.value_headers_data=$("#callbacks #value-headers-data").val();
       //ACK
       //jsonValidate.callbacks.channel_name_ack=$("#callbacks #channel-name-ack").val();

       if(jsonValidate.callbacks.channel_ack==="BATCH-URL"){
         jsonValidate.callbacks.linePattern_ack=$("#callbacks #linePattern-ack").val();
       }
      //  jsonValidate.callbacks.headers_ack=$("#callbacks #headers-ack").val();
      //  jsonValidate.callbacks.value_ack=$("#callbacks #value-ack").val();
       //STATUS
       //jsonValidate.callbacks.channel_name_status=$("#callbacks #channel-name-status").val();

       if(jsonValidate.callbacks.channel_status==="BATCH-URL"){
         jsonValidate.callbacks.linePattern_status=$("#callbacks #linePattern-status").val();
       }
       jsonValidate.callbacks.send_status=$("#callbacks #send-status").prop("checked");
       jsonValidate.callbacks.downlinkMode=$("#callbacks #downlinkMode").val();

      //  jsonValidate.callbacks.headers_status=$("#callbacks #headers-status").val();
      //  jsonValidate.callbacks.value_status=$("#callbacks #value-status").val();
     
       // MONSTERS!!!!!!!Check if Field Names ar

       jsonValidate.callbacks.customVariableData =  $("config-custom-payload-data").val();
       jsonValidate.callbacks.customVariableAck =  $("config-custom-payload-ack").val();
       jsonValidate.callbacks.customVariableStatus =  $("config-custom-payload-status").val();
       // NO MORE MONSTERS
    }

     // click on OK button into radio page
      $('#callbacks #validate').click(function(){
        getValuesRadio();
        getValuesDevices();
        getValuesCallbacks();
        var isValid = $("#downlink").val().match("(?:0[xX])?[0-9a-fA-F]{8}");
        console.log(isValid);
        if(!isValid && $("#downlinkMode").val() === "DIRECT"){
          //NOTIFICATION NEW VERSION
          $.notify.addStyle('ned', {
            html: "<div><span data-notify-text/>"+LBL_PROBLEM_DATA+"</div>",
            classes: {
              base: {
                "white-space": "nowrap",
                "background-color": "red",
                "padding": "30px",
                "margin-top":"100px",
                "border-style": "solid",
                "border-width": "1px",
                "border-color": "black",
                "color":"white"
              }
            }
          });

          $.notify(' ', {
            style: 'ned',
            autoHideDelay: 5000
          });
        }
        else{
          postConf(jsonValidate);
        }

      });


     // click on Cancel button into radio page
     $('#radio #Cancel').click(function(){
       var items = getConfiguration();
       $("#radio #operating-zone").val(items.radio_choice);
       $("#radio #operating-zone").change();
     });


     /** ******************************************************************* */
     /** ********************* CHANGE function ****************************** */
     /** ******************************************************************* */

     // choice control (callback page)
     $( "#channel-ack" ).change(function() {
       if($("#channel-ack").val()==="URL"){
         $('#ack-url').show();
         $('#ack-line').hide();
         $("#callbacks #http-post-ack").removeAttr("disabled");
       }
       else{
         $('#ack-url').show();
         $('#ack-line').show();
         $("#callbacks #http-post-ack").attr("disabled","disabled");
         $("#callbacks #http-post-ack").prop("checked","checked");
       }
     });

     // choice control (callback page)
     $( "#channel-data" ).change(function() {
       if($("#channel-data").val()==="URL"){
         $('#data-url').show();
         $('#data-line').hide();
         $("#callbacks #http-post-data").removeAttr("disabled");
       }
       else{
         $('#data-url').show();
         $('#data-line').show();
         $("#callbacks #http-post-data").prop("checked","checked");
         $("#callbacks #http-post-data").attr("disabled","disabled");

       }
     });

     // add line pattern(callback page)
     $( "#channel-status" ).change(function() {
       if($("#channel-status").val()==="URL"){
         $('#status-url').show();
         $('#status-line').hide();
         $("#callbacks #http-post-status").removeAttr("disabled");
       }
       else{
         $('#status-url').show();
         $('#status-line').show();
         $("#callbacks #http-post-status").prop("checked","checked");
         $("#callbacks #http-post-status").attr("disabled","disabled");
       }
     });

     // control choice and add help message
     $( "#downlinkMode" ).change(function() {
       if(($("#downlinkMode").val()==="DIRECT")){
         console.log($("#downlinkMode").val());
         $("#cbType option[value='UPLINK']").removeAttr("disabled");
         $("#cbType option[value='BIDIR']").removeAttr("selected");
         $("#cbType option[value='BIDIR']").attr("disabled", false);
         $("#cbType option[value='BIDIR']").attr("disabled", "disabled");
         $("#cbType option[value='UPLINK']").prop("selected",true);
         $("#choice_callback").hide();
         $("#downlink").val("");
         $("#downlink").removeAttr("disabled");
       }
       else{
         console.log("else");
         $("#downlink").val("");
         $("#downlink").attr("disabled", "disabled");
         if($("#downlinkMode").val()==="NO DOWNLINK"){
           $("#cbType option[value='UPLINK']").removeAttr("disabled");
           $("#cbType option[value='BIDIR']").removeAttr("selected");
           $("#cbType option[value='BIDIR']").attr("disabled", false);
           $("#cbType option[value='BIDIR']").attr("disabled", "disabled");
           $("#cbType option[value='UPLINK']").prop("selected",true);
         }
         else{
           $("#cbType option[value='BIDIR']").removeAttr("disabled");
           $("#cbType option[value='UPLINK']").removeAttr("selected");
           $("#cbType option[value='UPLINK']").attr("disabled", false);
           $("#cbType option[value='UPLINK']").attr("disabled", "disabled");
           $("#cbType option[value='BIDIR']").prop("selected",true);
         }
         $("#infoComboDirect").hide();
         $("#infoComboBIDIR").hide();
         $("#infoDataPB").hide();
         $("#choice_callback").show();
       }
     });

     // control choice and add help message
      $( "#cbType" ).change(function() {
        if($("#cbType").val()==="BIDIR"){
          $("#downlinkMode option[value='DIRECT']").removeAttr("disabled");
        }
        else{
          $("#downlinkMode option[value='DIRECT']").attr("disabled", false);
          $("#infoComboBIDIR").hide();
        }
      });

      $( "#cbType" ).focusout(function() {
        $("#infoComboDirect").hide();
      })

    });
