var URL_SATURATION='http://'+window.location.hostname+':'+window.location.port+'/ned/saturation';

SetCookie("saturation_displayed", false);

saturation = function (data) {
    if (data.saturation === true){
            if ($.parseJSON(readCookie("saturation_displayed")) != true){
            SetCookie("saturation_displayed", true);
            $.notify.addStyle('ned', {
                  html: "<div ><span data-notify-text/>Saturation Detected : Please take the device away from the transmitter."+
                  "<br><button id='ok_button' class='ok'>Ok</button></div>",
                  classes: {
                    base: {
                      "white-space": "nowrap",
                      "background-color": "#8024FF",
                      "padding": "30px",
                      "margin-top":"100px",
                      "margin-right":"50px",
                      "border-style": "solid",
                      "border-width": "1px",
                      "border-color": "black",
                      "color":"white"
                    }
                  }
                });
                $.notify(' ', {
                  style: 'ned',
                  autoHideDelay: DELAY_NOTIF,
                  autoHide: false,
                  clickToHide: false ,
                });
                $(document).on('click', '.ok', function() {
                  SetCookie("saturation_displayed", false);
                  $(this).trigger('notify-hide');
                });
        }
    }
    if (data.dongleDisconnected === true){
      $.blockUI({
						message : "<b>Dongle has been disconnected</b></br> " + LBL_SERVER_STOPPED,
						css : {
							"cursor" : "auto",
							"white-space" : "nowrap",
							"background-color" : "#8024FF",
							"padding" : "30px",
							"margin-top" : "100px",
							"border-style" : "solid",
							"border-width" : "1px",
							"border-color" : "black",
							"color" : "white",
							"width" : "600px",
							"opacity" : 0.5
						},
						overlayCSS : {
							"cursor" : 'auto'
						}
      });
    }
    if(data.authentication === false){
      $('#auth-action').attr('checked', false);
      $('#auth-disabled').show();
      $('#auth-enabled').hide();
    }
    else{
      $('#auth-disabled').hide();
      $('#auth-enabled').show();
    }
},
fetchSaturation = function () {
      $.getJSON(URL_SATURATION, saturation);
}

check_saturation = function(){
	refreshintervalId = setInterval(fetchSaturation,5000);
}