var URL_VERSION = 'http://' + window.location.hostname + ':' + window.location.port + '/ned/version';
var version_data = {};

// click on the top menu
$('#link_about').on('click', function () {
    $.getJSON(URL_VERSION, function (data) {
        version_data = data;
        version_data.version = version_data.version.replace(/\"/g, '');
        box_content = '<p class="version" style="padding:0 1em"> <b>Version</b>: ' + version_data.version + '</p>';
        console.log('version: ' + version_data.version);
    }).then(function () {
        if (typeof version_data.version !== 'undefined') {
            $('#modalbox>div')
                .find('.version')
                .remove()
                .end()
                .prepend(box_content);
            $('#modalbox').show();
        }
        else {
            alert('version could not be verified');
        }
    });
});

function closeModal() {
    $('#modalbox').hide();
}