#!/bin/sh
set -e
#set -x
PATH_SFX_USB_INFO="/opt/snek/usb_tools/sfx_usb.info"
PATH_USB_IDS="/var/lib/usbutils/usb.ids"
if [ ! -f $PATH_USB_IDS ] || [ ! -f $PATH_SFX_USB_INFO ]; then
  exit 0
fi

old_IFS=$IFS
IFS=$'\n'

temp_file=$( cat "$PATH_SFX_USB_INFO" )
if !  grep -Fxq "$temp_file" "$PATH_USB_IDS"
then
  cat "$PATH_SFX_USB_INFO" >> "$PATH_USB_IDS"
fi
IFS=$old_IFS
